﻿//code by !_CS_WTYNH_!

// AUTO SHOP //
/*mp.keys.bind(0x78, false, function () { // F9
    setAuto('models', JSON.stringify(autoData.testModels));
    setAuto('colors', JSON.stringify(autoData.testColors));
    setAuto('prices', JSON.stringify(autoData.testPrices));
    mp.events.call('openAuto');
});*/

let autoColors = ["Черный", "Белый", "Красный", "Оранжевый", "Желтый", "Зеленый", "Голубой", "Синий", "Фиолетовый"];
let autoModels = null;

let colors = {};
colors["Черный"] = [0, 0, 0];
colors["Белый"] = [225, 225, 225];
colors["Красный"] = [230, 0, 0];
colors["Оранжевый"] = [255, 115, 0];
colors["Желтый"] = [240, 240, 0];
colors["Зеленый"] = [0, 230, 0];
colors["Голубой"] = [0, 205, 255];
colors["Синий"] = [0, 0, 230];
colors["Фиолетовый"] = [190, 60, 165];

let auto = {
    model: null,
    color: null,
    entity: null,
}
const cameraRotator = require("cef/js/vie.js");

/*var vehCamPosition = new mp.Vector3(-42.3758, -1101.672, 26.42235);
var vehCamRotation = new mp.Vector3(0, 0, 1.701622);
var vehPosition = new mp.Vector3(-42.79771, -1095.676, 26.0117);
var vehRotation = new mp.Vector3(0, 0, -136.246);*/

function createCam(x, y, z, rx, ry, rz, viewangle) {
    // camera = mp.cameras.new("Cam", {x, y, z}, {x: rx, y: ry, z: rz}, viewangle);
    camera = mp.cameras.new("default");
    camera.setCoord(x, y, z);
    camera.setRot(rx, ry, rz, 2);
    camera.setFov(viewangle);
    camera.setActive(true);

    var vehPosition = new mp.Vector3(134.9819, -1196.723, 29.36534); // спавн авто
    cameraRotator.start(camera, vehPosition, vehPosition, new mp.Vector3(-3.0, 3.5, 0.5), 180);
    cameraRotator.setZBound(-0.8, 1.8);
    cameraRotator.setZUpMultipler(5);
    cameraRotator.pause(true);

    mp.game.cam.renderScriptCams(true, false, 3000, true, false);
}

mp.events.add('auto', (act, value) => {
if(new Date().getTime() - global.lastCheck < 1000)
    {
        mp.events.call('notify', 4, 9, "Слишком быстро", 1000);
        return;
    }
    global.lastCheck = new Date().getTime();   
 switch (act) {
        case "model":
            auto.model = autoModels[value];
            auto.entity.model = mp.game.joaat(autoModels[value]);

            auto.entity.setCustomPrimaryColour(colors[auto.color][0], colors[auto.color][1], colors[auto.color][2]);
            auto.entity.setCustomSecondaryColour(colors[auto.color][0], colors[auto.color][1], colors[auto.color][2])
            auto.entity.setRotation(-0.260336, -0.8071228, 59.29361, 2, true);  // ротация авто
            break;
        case "color":
            auto.color = autoColors[value];

            auto.entity.setCustomPrimaryColour(colors[autoColors[value]][0], colors[autoColors[value]][1], colors[autoColors[value]][2]);
            auto.entity.setCustomSecondaryColour(colors[autoColors[value]][0], colors[autoColors[value]][1], colors[autoColors[value]][2])
            break;
    }
});
mp.events.add('buyAuto', () => {
	if(new Date().getTime() - global.lastCheck < 50) return; 
	global.lastCheck = new Date().getTime();
    //mp.gui.chat.push('auto buy');

    global.menuClose();
    global.menu.execute('auto.active=0');

    mp.events.callRemote('carroomBuy', auto.model, auto.color);

    if (auto.entity == null) return;
    auto.entity.destroy();
    auto.entity = null;
})
mp.events.add('closeAuto', () => {
	if(new Date().getTime() - global.lastCheck < 50) return; 
	global.lastCheck = new Date().getTime();
    global.menuClose();
    global.menu.execute('auto.active=0');

    mp.events.callRemote('carroomCancel');

    if (auto.entity == null) return;
    auto.entity.destroy();
    auto.entity = null;
	cameraRotator.stop();
})
mp.events.add('openAuto', (models, prices) => {
    if (global.menuCheck()) return;
    autoModels = JSON.parse(models);

    setAuto('models', models);
    setAuto('colors', JSON.stringify(autoColors));
    setAuto('prices', prices);
    createCam(127.7417, -1198.483, 32.38284, 0, 0, 285.854, 50); // координаты камеры и ротация
	cameraRotator.pause(false);
    auto.entity = mp.vehicles.new(mp.game.joaat(autoModels[0]), new mp.Vector3(134.9819, -1196.723, 29.36534), // спавн авто
        {
            heading: 0,
            numberPlate: 'CARROOM',	
            alpha: 255,
            color: [[0, 0, 0], [0, 0, 0]],
            locked: false,
            engine: false,
            dimension: 0
        });
    auto.entity.setRotation(-0.260336, -0.8071228, 59.29361, 2, true); // ротация авто
    auto.color = "Черный";
    auto.model = autoModels[0];

    global.menuOpen();
    global.menu.execute(`auto.active=true`);
	
	/*cam = mp.cameras.new('default', new mp.Vector3(-787.2166, -229.2877, 38.03418), new mp.Vector3(0, 0, 324.0139), 50);
    cam.setActive(true);
    mp.game.cam.renderScriptCams(true, false, 0, true, false);*/
});